# -*- coding: iso-8859-1 -*-
"""
    MoinMoin leftsidebar theme - thanks to ...

    @copyright: 2003 by ThomasWaldmann (LinuxWiki:ThomasWaldmann)
    @license: GNU GPL, see COPYING for details.
"""

from MoinMoin import config, wikiutil
from classic import Theme as ThemeBase

class Theme(ThemeBase):
    """ This is the leftsidebar theme. """

    name = 'leftsidebar2'

    #stylesheets = ThemeBase.stylesheets + (
    stylesheets = (
        # theme charset         media       basename
        ('all',      'common'),
        ('screen',   'screen'),
        ('print',    'print'),
        )

    def make_iconlink(self, which, d):
        """
        Make a link with an icon

        @param which: icon id (dictionary key)
        @param d: parameter dictionary
        @rtype: string
        @return: html link tag
        """
        page_params, title, icon = config.page_icons_table[which]
        d['title'] = title % d
        d['i18ntitle'] = self.request.getText(d['title'])
        img_src = self.make_icon(icon, d)
        text = "%s&nbsp;%s" % (img_src, d['i18ntitle'])
        return wikiutil.link_tag(self.request, page_params % d, text, attrs='title="%(i18ntitle)s"' % d)

    def iconbar(self, d):
        """
        Assemble the iconbar
        
        @param d: parameter dictionary
        @rtype: string
        @return: iconbar html
        """
        iconbar = []
        if (hasattr(config,'page_iconbar') and config.page_iconbar) and self.request.user.show_toolbar and d['page_name']:
            iconbar.append('<ul id="iconbar">\n')
            icons = config.page_iconbar[:]
            for icon in icons:
                if icon == "up":
                    if d['page_parent_page']:
                        iconbar.append('<li>%s</li>\n' % self.make_iconlink(icon, d))
                elif icon == "subscribe":
                    iconbar.append('<li>%s</li>\n' % self.make_iconlink(
                        ["subscribe", "unsubscribe"][self.request.user.isSubscribedTo([d['page_name']])], d))
                elif icon == "home":
                    if d['page_home_page']:
                        iconbar.append('<li>%s</li>\n' % self.make_iconlink(icon, d))
                else:
                    iconbar.append('<li>%s</li>\n' % self.make_iconlink(icon, d))
            iconbar.append('</ul>\n')
        return ''.join(iconbar)

def execute(request):
    return Theme(request)

